## pop-os-popsicle.zip

=== Makefile ===
default_prefix = /usr/local
prefix ?= $(default_prefix)
exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin
libdir = $(exec_prefix)/lib
includedir = $(prefix)/include
datarootdir = $(prefix)/share
datadir = $(datarootdir)

CLI_SOURCES = $(shell find cli -type f -wholename '*src/*.rs') cli/Cargo.toml
GTK_SOURCES = $(shell find gtk -type f -wholename '*src/*.rs') gtk/Cargo.toml
SHR_SOURCES = $(shell find src -type f -wholename '*src/*.rs') Cargo.toml Cargo.lock

RELEASE = debug
DEBUG ?= 0
ifeq (0,$(DEBUG))
	ARGS = --release
	RELEASE = release
endif

VENDORED ?= 0
ifeq (1,$(VENDORED))
    ARGS += --frozen
endif

TARGET = target/$(RELEASE)

.PHONY: all clean distclean install uninstall update

BIN=popsicle
APPID=com.system76.Popsicle
APPDATA=$(APPID).appdata.xml
DESKTOP=$(APPID).desktop
GTK_BIN=popsicle-gtk
ICONS=\
	512x512/apps/$(APPID).png \
	16x16@2x/apps/$(APPID).png \
	32x32@2x/apps/$(APPID).png \
	32x32/apps/$(APPID).png \
	48x48@2x/apps/$(APPID).png \
	24x24/apps/$(APPID).png \
	48x48/apps/$(APPID).png \
	16x16/apps/$(APPID).png \
	24x24@2x/apps/$(APPID).png \
	512x512@2x/apps/$(APPID).png

all: cli gtk

cli: $(TARGET)/$(BIN) $(TARGET)/$(BIN).1.gz $(CLI_SOURCES) $(SHR_SOURCES)

gtk: $(TARGET)/$(GTK_BIN) $(GTK_SOURCES) $(SHR_SOURCES)

clean:
	cargo clean

distclean: clean
	rm -rf .cargo vendor vendor.tar

vendor: vendor.tar

vendor.tar:
	mkdir -p .cargo
	cargo vendor | head -n -1 > .cargo/config
	echo 'directory = "vendor"' >> .cargo/config
	tar pcf vendor.tar vendor
	rm -rf vendor

install-cli: cli
	install -Dm 0755 "$(TARGET)/$(BIN)" "$(DESTDIR)$(bindir)/$(BIN)"
	install -Dm 0644 "$(TARGET)/$(BIN).1.gz" "$(DESTDIR)$(datadir)/man/man1/$(BIN).1.gz"

install-gtk: gtk
	install -Dm 0755 "$(TARGET)/$(GTK_BIN)" "$(DESTDIR)$(bindir)/$(GTK_BIN)"
	install -Dm 0644 "gtk/assets/$(DESKTOP)" "$(DESTDIR)$(datadir)/applications/$(DESKTOP)"
	install -Dm 0644 "gtk/assets/$(APPDATA)" "$(DESTDIR)$(datadir)/metainfo/$(APPDATA)"
	for icon in $(ICONS); do \
		install -D -m 0644 "gtk/assets/icons/$$icon" "$(DESTDIR)$(datadir)/icons/hicolor/$$icon"; \
	done

install: all install-cli install-gtk

uninstall-cli:
	rm -f "$(DESTDIR)$(bindir)/$(BIN)"
	rm -f "$(DESTDIR)$(datadir)/man/man1/$(BIN).1.gz"

uninstall-gtk:
	rm -f "$(DESTDIR)$(bindir)/$(GTK_BIN)"
	rm -f "$(DESTDIR)$(datadir)/applications/$(DESKTOP)"
	for icon in $(ICONS); do \
		rm -f "$(DESTDIR)$(datadir)/icons/hicolor/$$icon"; \
	done

uninstall: uninstall-cli uninstall-gtk

update:
	cargo update

extract:
ifeq ($(VENDORED),1)
	tar pxf vendor.tar
endif

$(TARGET)/$(BIN): extract
	cargo build --manifest-path cli/Cargo.toml $(ARGS)

$(TARGET)/$(GTK_BIN): extract
	cargo build --manifest-path gtk/Cargo.toml $(ARGS)

$(TARGET)/$(BIN).1.gz: $(TARGET)/$(BIN)
	help2man --no-info $< | gzip -c > $@.partial
	mv $@.partial $@

=== debian/changelog ===
popsicle (1.3.3) jammy; urgency=medium

  * 1.3.3 release

 -- Michael Murphy <michael@mmurphy.dev>  Wed, 03 Jan 2024 16:24:46 +0100

popsicle (1.3.2) jammy; urgency=medium

  * 1.3.2 release 

 -- Michael Murphy <michael@mmurphy.dev>  Thu, 13 Jul 2023 17:34:00 +0200

popsicle (1.3.0) groovy; urgency=medium

  * 1.3.0 release

 -- Ian Douglas Scott <idscott@system76.com>  Thu, 05 Nov 2020 09:40:32 -0800

popsicle (1.2.0) groovy; urgency=medium

  * 1.2.0 Release 

 -- Ian Douglas Scott <idscott@system76.com>  Tue, 27 Oct 2020 13:42:44 -0700

popsicle (1.1.0) focal; urgency=medium

  * 1.1.0 release

 -- Ian Douglas Scott <idscott@system76.com>  Mon, 03 Aug 2020 10:48:06 -0700

popsicle (0.1.5) bionic; urgency=medium

  * 0.1.5 release

 -- Jeremy Soller <jeremy@system76.com>  Fri, 02 Mar 2018 12:48:11 -0700

popsicle (0.1.4) bionic; urgency=medium

  * 0.1.4 release

 -- Jeremy Soller <jeremy@system76.com>  Tue, 30 Jan 2018 14:54:54 -0700

popsicle (0.1.3) artful; urgency=medium

  * 0.1.3 release

 -- Jeremy Soller <jeremy@system76.com>  Tue, 07 Nov 2017 12:00:07 -0700

popsicle (0.1.2) artful; urgency=medium

  * 0.1.2 release

 -- Jeremy Soller <jeremy@system76.com>  Mon, 16 Oct 2017 13:39:01 -0600

=== debian/control ===
Source: popsicle
Section: utils
Priority: optional
Maintainer: Jeremy Soller <jeremy@system76.com>
Build-Depends:
  debhelper (>=9),
  cargo,
  help2man,
  libclang-dev,
  libgtk-3-dev
Standards-Version: 4.1.1
Homepage: https://github.com/pop-os/popsicle

Package: popsicle
Architecture: amd64 arm64
Depends:
  ${misc:Depends},
  ${shlib:Depends}
Description: USB Flasher

Package: popsicle-gtk
Architecture: amd64 arm64
Depends:
  libgtk-3-0,
  ${misc:Depends},
  ${shlib:Depends}
Description: GTK front end to the USB Flasher

=== debian/rules ===
#!/usr/bin/make -f

export VENDORED ?= 1
CLEAN ?= 1

%:
	dh $@

override_dh_auto_build:
	env CARGO_HOME="$$(pwd)/target/cargo" \
	dh_auto_build

override_dh_auto_clean:
ifeq ($(CLEAN),1)
	make clean
endif
ifeq ($(VENDORED),1)
	if ! ischroot; then \
		make vendor; \
	fi
endif

override_dh_auto_install:
	dh_auto_install -- prefix=/usr
